Index: /home/bes/dev/jboss/clean/trunk/ejb3/src/resources/META-INF/ejb3-deployers-jboss-beans.xml
===================================================================
--- /home/bes/dev/jboss/clean/trunk/ejb3/src/resources/META-INF/ejb3-deployers-jboss-beans.xml  (revision 77385)
+++ /home/bes/dev/jboss/clean/trunk/ejb3/src/resources/META-INF/ejb3-deployers-jboss-beans.xml  (working copy)
@@ -292,21 +292,15 @@
             <value>org.jboss.metadata.jpa.spec.PersistenceMetaData</value> 
          </parameter> 
       </uninstall> 
-   </bean> 
-
+   </bean>
+   
    <!-- 
     
-    JNDI Registrars
+    JNDI Registrars   
     
-    
     The JNDI Registrar is responsible for all JNDI Bindings for
-    an EJB.  Its constructor takes the following arguments, in order:
+    an EJB.
     
-    javax.naming.Context (JNDI Context into which to bind objects)
-    org.jboss.ejb3.proxy.spi.registry.ProxyFactoryRegistry (Implementation of ProxyFactoryRegistry)
-    String statelessSessionProxyObjectFactoryType The JNDI ObjectFactory implementation to use for SLSB
-    ...more later when SFSB, @Service, MDB Implemented
-    
   -->
 
   <!-- SLSB JNDI Registrar -->
@@ -328,5 +322,30 @@
       </parameter>
     </constructor>
   </bean>
+
+  <bean name="org.jboss.ejb3.ProxyClusteringRegistry"
+        class="org.jboss.ejb3.proxy.clustered.registry.ProxyClusteringRegistry"/>
+
+  <!-- Clustered SLSB JNDI Registrar -->
+  <bean name="org.jboss.ejb3.JndiRegistrar.Session.ClusteredSLSBJndiRegistrar"
+    class="org.jboss.ejb3.proxy.clustered.jndiregistrar.JndiClusteredStatelessSessionRegistrar">
+    <constructor>
+      <parameter>
+        org.jboss.ejb3.proxy.clustered.objectfactory.session.stateless.StatelessSessionClusteredProxyObjectFactory
+      </parameter>
+      <parameter><inject bean="org.jboss.ejb3.ProxyClusteringRegistry"/></parameter>
+    </constructor>
+  </bean>
+
+  <!-- Clustered SFSB JNDI Registrar -->
+  <bean name="org.jboss.ejb3.JndiRegistrar.Session.ClusteredSFSBJndiRegistrar"
+    class="org.jboss.ejb3.proxy.clustered.jndiregistrar.JndiClusteredStatefulSessionRegistrar">
+    <constructor>
+      <parameter>
+        org.jboss.ejb3.proxy.clustered.objectfactory.session.stateful.StatefulSessionClusteredProxyObjectFactory
+      </parameter>
+      <parameter><inject bean="org.jboss.ejb3.ProxyClusteringRegistry"/></parameter>
+    </constructor>
+  </bean>
     
 </deployment> 
Index: /home/bes/dev/jboss/clean/trunk/thirdparty/pom.xml
===================================================================
--- /home/bes/dev/jboss/clean/trunk/thirdparty/pom.xml  (revision 77385)
+++ /home/bes/dev/jboss/clean/trunk/thirdparty/pom.xml  (working copy)
@@ -520,6 +520,22 @@
             </dependency>
             <dependency>
               <groupId>org.jboss.ejb3</groupId>
+              <artifactId>jboss-ejb3-proxy-clustered</artifactId>
+              <mapping>
+                <componentId>jboss.jboss-ejb3-proxy-clustered</componentId>
+              </mapping>
+            </dependency>
+            <dependency>
+              <groupId>org.jboss.ejb3</groupId>
+              <artifactId>jboss-ejb3-proxy-clustered</artifactId>
+              <classifier>client</classifier>
+              <mapping>
+                <componentId>jboss.jboss-ejb3-proxy-clustered</componentId>
+                <artifactId>jboss-ejb3-proxy-clustered-client</artifactId>
+              </mapping>
+            </dependency>
+            <dependency>
+              <groupId>org.jboss.ejb3</groupId>
               <artifactId>jboss-ejb3-security</artifactId>
               <mapping>
                 <componentId>jboss.jboss-ejb3-security</componentId>
@@ -1334,6 +1350,11 @@
     </dependency>
     <dependency>
       <groupId>org.jboss.ejb3</groupId>
+      <artifactId>jboss-ejb3-proxy-clustered</artifactId>
+      <classifier>client</classifier>
+    </dependency>
+    <dependency>
+      <groupId>org.jboss.ejb3</groupId>
       <artifactId>jboss-ejb3-security</artifactId>
       <classifier>client</classifier>
     </dependency>
Index: /home/bes/dev/jboss/clean/trunk/component-matrix/pom.xml
===================================================================
--- /home/bes/dev/jboss/clean/trunk/component-matrix/pom.xml    (revision 77385)
+++ /home/bes/dev/jboss/clean/trunk/component-matrix/pom.xml    (working copy)
@@ -45,9 +45,10 @@
     <version.org.hibernate.entity.manager>3.4.0.GA</version.org.hibernate.entity.manager>
     <version.org.hibernate.validator>3.1.0.CR2</version.org.hibernate.validator>
     <version.org.jboss.aop>2.0.0.CR15</version.org.jboss.aop>
-    <version.org.jboss.ejb3>0.1.14</version.org.jboss.ejb3>
+    <version.org.jboss.ejb3>0.1.15-SNAPSHOT</version.org.jboss.ejb3>
     <version.org.jboss.ejb3.common.client>0.1.6</version.org.jboss.ejb3.common.client>
     <version.org.jboss.ejb3.proxy.client>0.1.2</version.org.jboss.ejb3.proxy.client>
+    <version.org.jboss.ejb3.proxy.clustered.client>0.1.3-SNAPSHOT</version.org.jboss.ejb3.proxy.clustered.client>
     <version.org.jboss.ejb3.security.client>0.13.1</version.org.jboss.ejb3.security.client>
     <version.org.jboss.jpa>0.1.1</version.org.jboss.jpa>
     <version.org.jboss.reflect>2.0.0.Beta13</version.org.jboss.reflect>
@@ -1474,6 +1475,13 @@
         <version>${version.org.jboss.ejb3.proxy.client}</version>
         <classifier>client</classifier>
       </dependency>
+    
+      <dependency>
+        <groupId>org.jboss.ejb3</groupId>
+        <artifactId>jboss-ejb3-proxy-clustered</artifactId>
+        <version>${version.org.jboss.ejb3.proxy.clustered.client}</version>
+        <classifier>client</classifier>
+      </dependency>
  
       <dependency>
         <groupId>org.jboss.ejb3</groupId>
Index: /home/bes/dev/jboss/clean/trunk/build/build-distr.xml
===================================================================
--- /home/bes/dev/jboss/clean/trunk/build/build-distr.xml       (revision 77385)
+++ /home/bes/dev/jboss/clean/trunk/build/build-distr.xml       (working copy)
@@ -176,6 +176,8 @@
                excludes="*-sources.jar, *-javadoc.jar"/>
       <fileset dir="${jboss.jboss.ejb3.proxy.lib}" includes="*.jar"
                excludes="*-sources.jar, *-javadoc.jar, *-client.jar, *-tests.jar"/>
+      <fileset dir="${jboss.jboss.ejb3.proxy.clustered.lib}" includes="*.jar"
+               excludes="*-sources.jar, *-javadoc.jar, *-client.jar, *-tests.jar"/>
       <fileset dir="${jboss.jboss.ejb3.security.lib}" includes="*.jar"
                excludes="*-sources.jar, *-javadoc.jar, *-client.jar, *-tests.jar"/>
        <fileset dir="${jboss.jboss.ejb3.transactions.lib}" includes="*.jar"
@@ -210,6 +212,7 @@
       <fileset dir="${jboss.jboss.ejb3.common.lib}" includes="*-client.jar" excludes="*sources.jar"/>
       <fileset dir="${jboss.jboss.ejb3.core.lib}" includes="*-client.jar" excludes="*sources.jar"/>
       <fileset dir="${jboss.jboss.ejb3.proxy.lib}" includes="*-client.jar" excludes="*sources.jar"/>
+      <fileset dir="${jboss.jboss.ejb3.proxy.clustered.lib}" includes="*-client.jar" excludes="*sources.jar"/>
       <fileset dir="${jboss.jboss.ejb3.security.lib}" includes="*-client.jar" excludes="*sources.jar"/>
     </copy>
   </target>