Index: test/org/hibernate/test/annotations/cascade/Mouth.java
===================================================================
--- test/org/hibernate/test/annotations/cascade/Mouth.java	(revisão 15697)
+++ test/org/hibernate/test/annotations/cascade/Mouth.java	(cópia de trabalho)
@@ -2,7 +2,9 @@
 package org.hibernate.test.annotations.cascade;
 
 import java.util.Collection;
+
 import javax.persistence.CascadeType;
+import javax.persistence.Column;
 import javax.persistence.Entity;
 import javax.persistence.GeneratedValue;
 import javax.persistence.Id;
@@ -16,6 +18,7 @@
 	@Id
 	@GeneratedValue
 	public Integer id;
+	@Column(name="xsize")
 	public int size;
 	@OneToMany(mappedBy = "mouth", cascade = CascadeType.REMOVE)
 	public Collection<Tooth> teeth;
Index: test/org/hibernate/test/annotations/query/Chaos.java
===================================================================
--- test/org/hibernate/test/annotations/query/Chaos.java	(revisão 15697)
+++ test/org/hibernate/test/annotations/query/Chaos.java	(cópia de trabalho)
@@ -1,36 +1,38 @@
 //$Id: $
 package org.hibernate.test.annotations.query;
 
+import java.util.HashSet;
 import java.util.Set;
-import java.util.HashSet;
+
+import javax.persistence.Column;
 import javax.persistence.Entity;
 import javax.persistence.Id;
-import javax.persistence.Table;
-import javax.persistence.NamedQuery;
+import javax.persistence.JoinColumn;
 import javax.persistence.NamedNativeQuery;
 import javax.persistence.OneToMany;
-import javax.persistence.JoinColumn;
+import javax.persistence.Table;
 
+import org.hibernate.annotations.Loader;
+import org.hibernate.annotations.SQLDelete;
+import org.hibernate.annotations.SQLDeleteAll;
 import org.hibernate.annotations.SQLInsert;
 import org.hibernate.annotations.SQLUpdate;
-import org.hibernate.annotations.SQLDelete;
-import org.hibernate.annotations.SQLDeleteAll;
-import org.hibernate.annotations.Loader;
 
 /**
  * @author Emmanuel Bernard
  */
 @Entity
 @Table(name="CHAOS")
-@SQLInsert( sql="INSERT INTO CHAOS(name, nickname, size, id) VALUES(upper(?),?,?,?)")
-@SQLUpdate( sql="UPDATE CHAOS SET name = upper(?), nickname = ?, size = ? WHERE id = ?")
+@SQLInsert( sql="INSERT INTO CHAOS(name, nickname, xsize, id) VALUES(upper(?),?,?,?)")
+@SQLUpdate( sql="UPDATE CHAOS SET name = upper(?), nickname = ?, xsize = ? WHERE id = ?")
 @SQLDelete( sql="DELETE CHAOS WHERE id = ?")
 @SQLDeleteAll( sql="DELETE CHAOS")
 @Loader(namedQuery = "chaos")
-@NamedNativeQuery(name="chaos", query="select id, size, name, lower( nickname ) as nickname from CHAOS where id= ?", resultClass = Chaos.class)
+@NamedNativeQuery(name="chaos", query="select id, xsize, name, lower( nickname ) as nickname from CHAOS where id= ?", resultClass = Chaos.class)
 public class Chaos {
 	@Id
 	private Long id;
+	@Column(name="xsize")
 	private Long size;
 	private String name;
 	private String nickname;
Index: test/org/hibernate/test/annotations/embedded/Book.java
===================================================================
--- test/org/hibernate/test/annotations/embedded/Book.java	(revisão 15697)
+++ test/org/hibernate/test/annotations/embedded/Book.java	(cópia de trabalho)
@@ -36,7 +36,7 @@
 	}
 
 	@AttributeOverrides({
-	@AttributeOverride(name = "size", column = @Column(table = "BookSummary")),
+	@AttributeOverride(name = "size", column = @Column(table = "BookSummary", name="xsize")),
 	@AttributeOverride(name = "text", column = @Column(table = "BookSummary"))
 			})
 	public Summary getSummary() {
Index: test/org/hibernate/test/annotations/embedded/Summary.java
===================================================================
--- test/org/hibernate/test/annotations/embedded/Summary.java	(revisão 15697)
+++ test/org/hibernate/test/annotations/embedded/Summary.java	(cópia de trabalho)
@@ -1,6 +1,7 @@
 //$Id$
 package org.hibernate.test.annotations.embedded;
 
+import javax.persistence.Column;
 import javax.persistence.Embeddable;
 
 import org.hibernate.annotations.Parent;
@@ -14,6 +15,7 @@
 	private String text;
 	private Book summarizedBook;
 
+	@Column(name="xsize")
 	public int getSize() {
 		return size;
 	}
Index: test/org/hibernate/test/annotations/inheritance/Tomato.java
===================================================================
--- test/org/hibernate/test/annotations/inheritance/Tomato.java	(revisão 15697)
+++ test/org/hibernate/test/annotations/inheritance/Tomato.java	(cópia de trabalho)
@@ -1,6 +1,7 @@
 //$Id$
 package org.hibernate.test.annotations.inheritance;
 
+import javax.persistence.Column;
 import javax.persistence.Entity;
 import javax.persistence.Inheritance;
 import javax.persistence.InheritanceType;
@@ -21,6 +22,7 @@
 public class Tomato extends Vegetable {
 	private int size;
 
+	@Column(name="xsize")
 	public int getSize() {
 		return size;
 	}
Index: test/org/hibernate/test/annotations/inheritance/mixed/Document.java
===================================================================
--- test/org/hibernate/test/annotations/inheritance/mixed/Document.java	(revisão 15697)
+++ test/org/hibernate/test/annotations/inheritance/mixed/Document.java	(cópia de trabalho)
@@ -25,7 +25,7 @@
 		this.size = size;
 	}
 
-	@Column(table = "DocumentMixed", nullable = false)
+	@Column(table = "DocumentMixed", nullable = false, name="xsize")
 	public int getSize() {
 		return size;
 	}
Index: test/org/hibernate/test/annotations/access/BigBed.java
===================================================================
--- test/org/hibernate/test/annotations/access/BigBed.java	(revisão 15697)
+++ test/org/hibernate/test/annotations/access/BigBed.java	(cópia de trabalho)
@@ -1,6 +1,7 @@
 //$Id$
 package org.hibernate.test.annotations.access;
 
+import javax.persistence.Column;
 import javax.persistence.Entity;
 
 /**
@@ -8,5 +9,6 @@
  */
 @Entity
 public class BigBed extends Bed {
+	@Column(name="xsize")
 	public int size;
 }