Index: userInputSpec.xml
===================================================================
--- userInputSpec.xml	(revision 1152)
+++ userInputSpec.xml	(working copy)
@@ -10,7 +10,7 @@
 
       <!-- JMX interface security -->
       <field type="staticText" align="left"
-         txt="This section allows you to control whether the JMX interfaces are secured. See http://wiki.jboss.org/wiki/Wiki.jsp?page=SecureJBoss for additional security configuration."
+         txt="This section allows you to control whether the JMX interfaces are secured. See http://www.redhat.com/docs/en-US/JBoss_Enterprise_Application_Platform/5.0.0.BETA/html-single/Installation_Guide/index.html#Post_Installation_Configuration for additional security configuration."
          id="jmxSecurityText"/>
       <field type="check" variable="secureJmxConsole">
          <!--
Index: local-izpack/bin/langpacks/installer/por.xml
===================================================================
--- local-izpack/bin/langpacks/installer/por.xml	(revision 1152)
+++ local-izpack/bin/langpacks/installer/por.xml	(working copy)
@@ -192,7 +192,7 @@
 <str id="combo.jdatastore" txt="Jdatastore"/>
 <str id="web-console" txt="web-console"/>
 <str id="jta-service.description" txt="O Serviço JTA"/>
-<str id="jmxSecurityText" txt="Esta seção permite que você controle a segurança das interfaces JMX. Veja em http://wiki.jboss.org/wiki/Wiki.jsp?page=SecureJBoss para maiores informações sobre configuração de segurança."/>
+<str id="jmxSecurityText" txt="Esta seção permite que você controle a segurança das interfaces JMX. Veja em http://www.redhat.com/docs/en-US/JBoss_Enterprise_Application_Platform/5.0.0.BETA/html-single/Installation_Guide/index.html#Post_Installation_Configuration para maiores informações sobre configuração de segurança."/>
 <str id="jboss-rules-src" txt="jboss-rules-src"/>
 <str id="jboss-ha-xa-jdbc" txt="jboss-ha-xa-jdbc"/>
 <str id="keystore.division.organization" txt="Divisão/Organização"/>
Index: local-izpack/bin/langpacks/installer/spa.xml
===================================================================
--- local-izpack/bin/langpacks/installer/spa.xml	(revision 1152)
+++ local-izpack/bin/langpacks/installer/spa.xml	(working copy)
@@ -192,7 +192,7 @@
 <str id="combo.jdatastore" txt="Jdatastore"/>
 <str id="web-console" txt="web-console"/>
 <str id="jta-service.description" txt="El servicio JTA"/>
-<str id="jmxSecurityText" txt="Esta sección le permite controlar si las interfaces JMX son aseguradas. Véa http://wiki.jboss.org/wiki/Wiki.jsp?page=SecureJBoss para obtener configuraciones de seguridad adicionales."/>
+<str id="jmxSecurityText" txt="Esta sección le permite controlar si las interfaces JMX son aseguradas. Véa http://www.redhat.com/docs/en-US/JBoss_Enterprise_Application_Platform/5.0.0.BETA/html-single/Installation_Guide/index.html#Post_Installation_Configuration para obtener configuraciones de seguridad adicionales."/>
 <str id="jboss-rules-src" txt="jboss-rules-src"/>
 <str id="jboss-ha-xa-jdbc" txt="jboss-ha-xa-jdbc"/>
 <str id="keystore.division.organization" txt="División/Organización"/>
Index: local-izpack/bin/langpacks/installer/cat.xml
===================================================================
--- local-izpack/bin/langpacks/installer/cat.xml	(revision 1152)
+++ local-izpack/bin/langpacks/installer/cat.xml	(working copy)
@@ -548,7 +548,7 @@
    <str id="isolation" txt="cat:Isolation and Call by Value Semantics"/>
    <str id="jmxConsoleDomain.text" txt="cat:The JAAS security domain name for the jmx access points"/>
    <str id="jmxSecurity" txt="cat: JMX Security"/>
-   <str id="jmxSecurityText" txt="cat:This section allows you to control whether the JMX interfaces are secured. See http://wiki.jboss.org/wiki/Wiki.jsp?page=SecureJBoss for additional security configuration."/>
+   <str id="jmxSecurityText" txt="cat:This section allows you to control whether the JMX interfaces are secured. See http://www.redhat.com/docs/en-US/JBoss_Enterprise_Application_Platform/5.0.0.BETA/html-single/Installation_Guide/index.html#Post_Installation_Configuration for additional security configuration."/>
    <str id="keystore.city.locality" txt="cat:City/Locality"/>
    <str id="keystore.company.org" txt="cat:Company/Organization Unit"/>
    <str id="keystore.country" txt="cat:Country (2 letter)"/>
Index: local-izpack/bin/langpacks/installer/jpn.xml
===================================================================
--- local-izpack/bin/langpacks/installer/jpn.xml	(revision 1152)
+++ local-izpack/bin/langpacks/installer/jpn.xml	(working copy)
@@ -192,7 +192,7 @@
 <str id="combo.jdatastore" txt="Jdatastore"/>
 <str id="web-console" txt="web-console"/>
 <str id="jta-service.description" txt="JTA サービス"/>
-<str id="jmxSecurityText" txt="このセクションでは JMX インターフェースが保護されたかどうかコントロールすることを可能にします。追加のセキュリティ設定については、 http://wiki.jboss.org/wiki/Wiki.jsp?page=SecureJBoss を参照してください。"/>
+<str id="jmxSecurityText" txt="このセクションでは JMX インターフェースが保護されたかどうかコントロールすることを可能にします。追加のセキュリティ設定については、 http://www.redhat.com/docs/en-US/JBoss_Enterprise_Application_Platform/5.0.0.BETA/html-single/Installation_Guide/index.html#Post_Installation_Configuration を参照してください。"/>
 <str id="jboss-rules-src" txt="jboss-rules-src"/>
 <str id="jboss-ha-xa-jdbc" txt="jboss-ha-xa-jdbc"/>
 <str id="keystore.division.organization" txt="部門/組織"/>
Index: local-izpack/bin/langpacks/installer/chn.xml
===================================================================
--- local-izpack/bin/langpacks/installer/chn.xml	(revision 1152)
+++ local-izpack/bin/langpacks/installer/chn.xml	(working copy)
@@ -192,7 +192,7 @@
 <str id="combo.jdatastore" txt="Jdatastore"/>
 <str id="web-console" txt="web-console"/>
 <str id="jta-service.description" txt="JTA 服务"/>
-<str id="jmxSecurityText" txt="这部分内容允许你控制是否对 JMX 接口进行安全配置。请参考 http://wiki.jboss.org/wiki/Wiki.jsp?page=SecureJBoss 来获得更多的安全配置方面的信息。"/>
+<str id="jmxSecurityText" txt="这部分内容允许你控制是否对 JMX 接口进行安全配置。请参考 http://www.redhat.com/docs/en-US/JBoss_Enterprise_Application_Platform/5.0.0.BETA/html-single/Installation_Guide/index.html#Post_Installation_Configuration 来获得更多的安全配置方面的信息。"/>
 <str id="jboss-rules-src" txt="jboss-rules-src"/>
 <str id="jboss-ha-xa-jdbc" txt="jboss-ha-xa-jdbc"/>
 <str id="keystore.division.organization" txt="部门／组织"/>
Index: local-izpack/bin/langpacks/installer/fra.xml
===================================================================
--- local-izpack/bin/langpacks/installer/fra.xml	(revision 1152)
+++ local-izpack/bin/langpacks/installer/fra.xml	(working copy)
@@ -192,7 +192,7 @@
 <str id="combo.jdatastore" txt="Jdatastore"/>
 <str id="web-console" txt="web-console"/>
 <str id="jta-service.description" txt="Le service JTA"/>
-<str id="jmxSecurityText" txt="La section vous permet de contrôler si les interfaces JMX sont sécurisées. Consultez http://wiki.jboss.org/wiki/Wiki.jsp?page=SecureJBoss pour plus d'informations sur la sécurité."/>
+<str id="jmxSecurityText" txt="La section vous permet de contrôler si les interfaces JMX sont sécurisées. Consultez http://www.redhat.com/docs/en-US/JBoss_Enterprise_Application_Platform/5.0.0.BETA/html-single/Installation_Guide/index.html#Post_Installation_Configuration pour plus d'informations sur la sécurité."/>
 <str id="jboss-rules-src" txt="jboss-rules-src"/>
 <str id="jboss-ha-xa-jdbc" txt="jboss-ha-xa-jdbc"/>
 <str id="keystore.division.organization" txt="Division/organisation"/>
Index: local-izpack/bin/langpacks/installer/eng.xml
===================================================================
--- local-izpack/bin/langpacks/installer/eng.xml	(revision 1152)
+++ local-izpack/bin/langpacks/installer/eng.xml	(working copy)
@@ -549,7 +549,7 @@
    <str id="isolation" txt="Isolation and Call by Value Semantics"/>
    <str id="jmxConsoleDomain.text" txt="The JAAS security domain name for the jmx access points"/>
    <str id="jmxSecurity" txt=" JMX Security"/>
-   <str id="jmxSecurityText" txt="This section allows you to control whether the JMX interfaces are secured. See http://wiki.jboss.org/wiki/Wiki.jsp?page=SecureJBoss for additional security configuration."/>
+   <str id="jmxSecurityText" txt="This section allows you to control whether the JMX interfaces are secured. See http://www.redhat.com/docs/en-US/JBoss_Enterprise_Application_Platform/5.0.0.BETA/html-single/Installation_Guide/index.html#Post_Installation_Configuration for additional security configuration."/>
    <str id="keystore.city.locality" txt="City/Locality"/>
    <str id="keystore.company.org" txt="Company/Organization Unit"/>
    <str id="keystore.country" txt="Country (2 letter)"/>
Index: local-izpack/bin/langpacks/installer/deu.xml
===================================================================
--- local-izpack/bin/langpacks/installer/deu.xml	(revision 1152)
+++ local-izpack/bin/langpacks/installer/deu.xml	(working copy)
@@ -192,7 +192,7 @@
 <str id="combo.jdatastore" txt="Jdatastore"/>
 <str id="web-console" txt="web-console"/>
 <str id="jta-service.description" txt="Der JTA-Dienst"/>
-<str id="jmxSecurityText" txt="Dieser Abschnitt erlaubt es Ihnen zu bestimmen, ob die JMX-Interfaces gesichert werden. Für weitere Sicherheitskonfigurationen siehe http://wiki.jboss.org/wiki/Wiki.jsp?page=SecureJBoss."/>
+<str id="jmxSecurityText" txt="Dieser Abschnitt erlaubt es Ihnen zu bestimmen, ob die JMX-Interfaces gesichert werden. Für weitere Sicherheitskonfigurationen siehe http://www.redhat.com/docs/en-US/JBoss_Enterprise_Application_Platform/5.0.0.BETA/html-single/Installation_Guide/index.html#Post_Installation_Configuration."/>
 <str id="jboss-rules-src" txt="jboss-rules-src"/>
 <str id="jboss-ha-xa-jdbc" txt="jboss-ha-xa-jdbc"/>
 <str id="keystore.division.organization" txt="Abteilung/Organisation"/>